#!/bin/bash
#
# 2022/04/10

# 短時間避免因為LOAD問題再次重啟httpd
if [ -e /tmp/httpd_restart_hold.txt ]; then
   exit
fi

LOAD=`cat /proc/loadavg | awk -F\. '{print $1}'`

if (("$LOAD" > "70")); then

touch /tmp/httpd_restart_hold.txt

# Process
echo '' > /tmp/load.txt
echo 'CPU Usage TOP' >> /tmp/load.txt
echo '==========' >> /tmp/load.txt
echo '' >> /tmp/load.txt
ps aux --sort=-%cpu | head -n 15 | grep -v mysql | grep -v root | grep -v nobody >> /tmp/load.txt
echo '' >> /tmp/load.txt
echo '==========' >> /tmp/load.txt

# Apache
echo '' >> /tmp/load.txt
echo 'Apache Connect IP TOP' >> /tmp/load.txt
echo '==========' >> /tmp/load.txt
echo '' >> /tmp/load.txt
curl -s 127.0.0.1/whm-server-status | grep '<td nowrap>' | awk -F'>' '{print $7}' | grep -v '^<' | sort | uniq -c | sort -n | awk -F\< '{print $1}' | tail -n 10 >> /tmp/load.txt
echo '' >> /tmp/load.txt
echo '==========' >> /tmp/load.txt

# MySQL processlist
echo '' >> /tmp/load.txt
echo 'MySQL Processlist' >> /tmp/load.txt
echo '==========' >> /tmp/load.txt
echo '' >> /tmp/load.txt
mysql -e 'show full processlist\G' >> /tmp/load.txt
echo '' >> /tmp/load.txt
echo '==========' >> /tmp/load.txt

# httpd service stop
/scripts/restartsrv_httpd stop

cat /tmp/load.txt | mutt -s `hostname`' LOAD大於70暫停httpd一分鐘' support@twnoc.net,jacky@host.com.tw

# httpd service start
sleep 60
/scripts/restartsrv_httpd start

rm -f /tmp/load.txt

# 等候半小時
sleep 1800

rm -f /tmp/httpd_restart_hold.txt

fi

